
_interrupt:

;serialcomm.c,8 :: 		void interrupt () {
;serialcomm.c,9 :: 		if (PIR1.RCIF) {     // test the interrupt for uart rx
	BTFSS       PIR1+0, 5 
	GOTO        L_interrupt0
;serialcomm.c,10 :: 		PIR1.RCIF=0;
	BCF         PIR1+0, 5 
;serialcomm.c,11 :: 		rxchar = UART1_Read();  //read a byte from UART
	CALL        _UART1_Read+0, 0
	MOVF        R0, 0 
	MOVWF       _rxchar+0 
;serialcomm.c,13 :: 		switch(state){
	GOTO        L_interrupt1
;serialcomm.c,14 :: 		case WAIT_FOR_1C:   //wait till 1C is arrived
L_interrupt3:
;serialcomm.c,15 :: 		if(j>1){
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORWF       _j+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt19
	MOVF        _j+0, 0 
	SUBLW       1
L__interrupt19:
	BTFSC       STATUS+0, 0 
	GOTO        L_interrupt4
;serialcomm.c,16 :: 		j=1;
	MOVLW       1
	MOVWF       _j+0 
	MOVLW       0
	MOVWF       _j+1 
;serialcomm.c,17 :: 		testbuf[0]=testbuf[1];
	MOVF        _testbuf+1, 0 
	MOVWF       _testbuf+0 
;serialcomm.c,18 :: 		testbuf[j]=rxchar;
	MOVLW       _testbuf+0
	ADDWF       _j+0, 0 
	MOVWF       FSR1L 
	MOVLW       hi_addr(_testbuf+0)
	ADDWFC      _j+1, 0 
	MOVWF       FSR1H 
	MOVF        _rxchar+0, 0 
	MOVWF       POSTINC1+0 
;serialcomm.c,19 :: 		j++;
	INFSNZ      _j+0, 1 
	INCF        _j+1, 1 
;serialcomm.c,20 :: 		if(strstr(testbuf,"1C")!=0){
	MOVLW       _testbuf+0
	MOVWF       FARG_strstr_s1+0 
	MOVLW       hi_addr(_testbuf+0)
	MOVWF       FARG_strstr_s1+1 
	MOVLW       ?lstr1_serialcomm+0
	MOVWF       FARG_strstr_s2+0 
	MOVLW       hi_addr(?lstr1_serialcomm+0)
	MOVWF       FARG_strstr_s2+1 
	CALL        _strstr+0, 0
	MOVLW       0
	XORWF       R1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt20
	MOVLW       0
	XORWF       R0, 0 
L__interrupt20:
	BTFSC       STATUS+0, 2 
	GOTO        L_interrupt5
;serialcomm.c,21 :: 		j=0;
	CLRF        _j+0 
	CLRF        _j+1 
;serialcomm.c,22 :: 		state = WAIT_FOR_6bytes;
	MOVLW       1
	MOVWF       _state+0 
;serialcomm.c,23 :: 		}
L_interrupt5:
;serialcomm.c,24 :: 		}
L_interrupt4:
;serialcomm.c,25 :: 		testbuf[j]=rxchar;
	MOVLW       _testbuf+0
	ADDWF       _j+0, 0 
	MOVWF       FSR1L 
	MOVLW       hi_addr(_testbuf+0)
	ADDWFC      _j+1, 0 
	MOVWF       FSR1H 
	MOVF        _rxchar+0, 0 
	MOVWF       POSTINC1+0 
;serialcomm.c,26 :: 		j++;
	INFSNZ      _j+0, 1 
	INCF        _j+1, 1 
;serialcomm.c,27 :: 		if(strstr(testbuf,"1C")!=0){
	MOVLW       _testbuf+0
	MOVWF       FARG_strstr_s1+0 
	MOVLW       hi_addr(_testbuf+0)
	MOVWF       FARG_strstr_s1+1 
	MOVLW       ?lstr2_serialcomm+0
	MOVWF       FARG_strstr_s2+0 
	MOVLW       hi_addr(?lstr2_serialcomm+0)
	MOVWF       FARG_strstr_s2+1 
	CALL        _strstr+0, 0
	MOVLW       0
	XORWF       R1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt21
	MOVLW       0
	XORWF       R0, 0 
L__interrupt21:
	BTFSC       STATUS+0, 2 
	GOTO        L_interrupt6
;serialcomm.c,28 :: 		j=0;
	CLRF        _j+0 
	CLRF        _j+1 
;serialcomm.c,29 :: 		state = WAIT_FOR_6bytes;
	MOVLW       1
	MOVWF       _state+0 
;serialcomm.c,30 :: 		}
L_interrupt6:
;serialcomm.c,31 :: 		break;
	GOTO        L_interrupt2
;serialcomm.c,32 :: 		case WAIT_FOR_6bytes:
L_interrupt7:
;serialcomm.c,33 :: 		i++;
	INFSNZ      _i+0, 1 
	INCF        _i+1, 1 
;serialcomm.c,34 :: 		if(i>=6){
	MOVLW       128
	XORWF       _i+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt22
	MOVLW       6
	SUBWF       _i+0, 0 
L__interrupt22:
	BTFSS       STATUS+0, 0 
	GOTO        L_interrupt8
;serialcomm.c,35 :: 		i=0;
	CLRF        _i+0 
	CLRF        _i+1 
;serialcomm.c,36 :: 		state=RECEIVING;
	MOVLW       2
	MOVWF       _state+0 
;serialcomm.c,37 :: 		}
L_interrupt8:
;serialcomm.c,38 :: 		break;
	GOTO        L_interrupt2
;serialcomm.c,39 :: 		case RECEIVING:
L_interrupt9:
;serialcomm.c,41 :: 		if(count==1024){
	MOVF        _count+1, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt23
	MOVLW       0
	XORWF       _count+0, 0 
L__interrupt23:
	BTFSS       STATUS+0, 2 
	GOTO        L_interrupt10
;serialcomm.c,42 :: 		count=0;
	CLRF        _count+0 
	CLRF        _count+1 
;serialcomm.c,43 :: 		rc_ptr=buf;
	MOVLW       _buf+0
	MOVWF       _rc_ptr+0 
	MOVLW       hi_addr(_buf+0)
	MOVWF       _rc_ptr+1 
;serialcomm.c,44 :: 		}
L_interrupt10:
;serialcomm.c,45 :: 		*rc_ptr=rxchar;
	MOVFF       _rc_ptr+0, FSR1L
	MOVFF       _rc_ptr+1, FSR1H
	MOVF        _rxchar+0, 0 
	MOVWF       POSTINC1+0 
;serialcomm.c,46 :: 		rc_ptr++;
	INFSNZ      _rc_ptr+0, 1 
	INCF        _rc_ptr+1, 1 
;serialcomm.c,47 :: 		count++;
	INFSNZ      _count+0, 1 
	INCF        _count+1, 1 
;serialcomm.c,48 :: 		if(count%8==0){
	MOVLW       8
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVF        _count+0, 0 
	MOVWF       R0 
	MOVF        _count+1, 0 
	MOVWF       R1 
	CALL        _Div_16x16_S+0, 0
	MOVF        R8, 0 
	MOVWF       R0 
	MOVF        R9, 0 
	MOVWF       R1 
	MOVLW       0
	XORWF       R1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__interrupt24
	MOVLW       0
	XORWF       R0, 0 
L__interrupt24:
	BTFSS       STATUS+0, 2 
	GOTO        L_interrupt11
;serialcomm.c,49 :: 		msgs=msgs+1;
	INFSNZ      _msgs+0, 1 
	INCF        _msgs+1, 1 
;serialcomm.c,50 :: 		state=WAIT_FOR_1C ;
	CLRF        _state+0 
;serialcomm.c,51 :: 		}
L_interrupt11:
;serialcomm.c,52 :: 		break;
	GOTO        L_interrupt2
;serialcomm.c,53 :: 		} // end interrupt
L_interrupt1:
	MOVF        _state+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_interrupt3
	MOVF        _state+0, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L_interrupt7
	MOVF        _state+0, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_interrupt9
L_interrupt2:
;serialcomm.c,54 :: 		}
L_interrupt0:
;serialcomm.c,55 :: 		if( INTCON.TMR0IF == 1){
	BTFSS       INTCON+0, 2 
	GOTO        L_interrupt12
;serialcomm.c,56 :: 		LATA=0xFF;
	MOVLW       255
	MOVWF       LATA+0 
;serialcomm.c,57 :: 		}
L_interrupt12:
;serialcomm.c,58 :: 		}
L__interrupt18:
	RETFIE      1
; end of _interrupt

_main:

;serialcomm.c,60 :: 		void main () {
;serialcomm.c,61 :: 		ANSELA=0;
	CLRF        ANSELA+0 
;serialcomm.c,62 :: 		ANSELC=0;
	CLRF        ANSELC+0 
;serialcomm.c,63 :: 		TRISA=0;
	CLRF        TRISA+0 
;serialcomm.c,64 :: 		LATA=0x00;
	CLRF        LATA+0 
;serialcomm.c,66 :: 		INTCON.GIE = 1;      //enable global interrupt
	BSF         INTCON+0, 7 
;serialcomm.c,67 :: 		INTCON.PEIE = 1;
	BSF         INTCON+0, 6 
;serialcomm.c,68 :: 		PIE1.RCIE = 1; //enable receive interrupt.
	BSF         PIE1+0, 5 
;serialcomm.c,69 :: 		UART1_Init(19200);
	MOVLW       25
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;serialcomm.c,70 :: 		rc_ptr=buf;
	MOVLW       _buf+0
	MOVWF       _rc_ptr+0 
	MOVLW       hi_addr(_buf+0)
	MOVWF       _rc_ptr+1 
;serialcomm.c,71 :: 		tx_ptr=buf;
	MOVLW       _buf+0
	MOVWF       _tx_ptr+0 
	MOVLW       hi_addr(_buf+0)
	MOVWF       _tx_ptr+1 
;serialcomm.c,72 :: 		while(1) {   // Begin endless loop
L_main13:
;serialcomm.c,75 :: 		while(msgs!=0){         //read all the messages
L_main15:
	MOVLW       0
	XORWF       _msgs+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__main25
	MOVLW       0
	XORWF       _msgs+0, 0 
L__main25:
	BTFSC       STATUS+0, 2 
	GOTO        L_main16
;serialcomm.c,77 :: 		strncpy(output,tx_ptr,8);   //copy 8 bytes from the buffer
	MOVLW       _output+0
	MOVWF       FARG_strncpy_to+0 
	MOVLW       hi_addr(_output+0)
	MOVWF       FARG_strncpy_to+1 
	MOVF        _tx_ptr+0, 0 
	MOVWF       FARG_strncpy_from+0 
	MOVF        _tx_ptr+1, 0 
	MOVWF       FARG_strncpy_from+1 
	MOVLW       8
	MOVWF       FARG_strncpy_size+0 
	MOVLW       0
	MOVWF       FARG_strncpy_size+1 
	CALL        _strncpy+0, 0
;serialcomm.c,78 :: 		Uart1_Write_Text("DATA:");
	MOVLW       ?lstr3_serialcomm+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr3_serialcomm+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;serialcomm.c,79 :: 		Uart1_Write_Text(output);
	MOVLW       _output+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_output+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;serialcomm.c,80 :: 		Uart1_Write(13);              //new line char
	MOVLW       13
	MOVWF       FARG_UART1_Write_data_+0 
	CALL        _UART1_Write+0, 0
;serialcomm.c,81 :: 		tx_ptr=tx_ptr+8;               // increment the tr_ptr to the next 8 bytes
	MOVLW       8
	ADDWF       _tx_ptr+0, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      _tx_ptr+1, 0 
	MOVWF       R1 
	MOVF        R0, 0 
	MOVWF       _tx_ptr+0 
	MOVF        R1, 0 
	MOVWF       _tx_ptr+1 
;serialcomm.c,82 :: 		if( tx_ptr - buf ==1024){      //if tx_ptr reaches the end of buffer loop back to beginning
	MOVLW       _buf+0
	SUBWF       R0, 0 
	MOVWF       R2 
	MOVLW       hi_addr(_buf+0)
	SUBWFB      R1, 0 
	MOVWF       R3 
	MOVF        R3, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L__main26
	MOVLW       0
	XORWF       R2, 0 
L__main26:
	BTFSS       STATUS+0, 2 
	GOTO        L_main17
;serialcomm.c,83 :: 		tx_ptr = buf;
	MOVLW       _buf+0
	MOVWF       _tx_ptr+0 
	MOVLW       hi_addr(_buf+0)
	MOVWF       _tx_ptr+1 
;serialcomm.c,84 :: 		}
L_main17:
;serialcomm.c,85 :: 		msgs=msgs-1;
	MOVLW       1
	SUBWF       _msgs+0, 1 
	MOVLW       0
	SUBWFB      _msgs+1, 1 
;serialcomm.c,86 :: 		}
	GOTO        L_main15
L_main16:
;serialcomm.c,87 :: 		} // end while
	GOTO        L_main13
;serialcomm.c,88 :: 		} // end main
	GOTO        $+0
; end of _main
