 char rxchar;  //variable for storing data from UART
 int i = 0, flag = 0,count=0,j=0,msgs=0;  // array counter and flag to write once the desired pattern is read
 char buf[1025];   // array to store the received charaters
 char *rc_ptr,*tx_ptr;
 char output[15],testbuf[2]; //array to write data to tx
 enum{WAIT_FOR_1C,WAIT_FOR_6bytes,RECEIVING} state=WAIT_FOR_1C;
 /*******************************************************************************/
void interrupt () {
  if (PIR1.RCIF) {     // test the interrupt for uart rx
      PIR1.RCIF=0;
     rxchar = UART1_Read();  //read a byte from UART

      switch(state){
               case WAIT_FOR_1C:   //wait till 1C is arrived
               if(j>1){
               j=1;
               testbuf[0]=testbuf[1];
               testbuf[j]=rxchar;
               j++;
                   if(strstr(testbuf,"1C")!=0){
                   j=0;
                   state = WAIT_FOR_6bytes;
                     }
               }
               testbuf[j]=rxchar;
               j++;
                   if(strstr(testbuf,"1C")!=0){
                   j=0;
                   state = WAIT_FOR_6bytes;
                         }
               break;
               case WAIT_FOR_6bytes:
                i++;
                if(i>=6){
                 i=0;
                 state=RECEIVING;
                }
               break;
               case RECEIVING:

               if(count==1024){
                  count=0;
                  rc_ptr=buf;
               }
               *rc_ptr=rxchar;
               rc_ptr++;
               count++;
               if(count%8==0){
               msgs=msgs+1;
               state=WAIT_FOR_1C ;
               }
               break;
   } // end interrupt
  }
  if( INTCON.TMR0IF == 1){
    LATA=0xFF;
  }
  }
  /******************************************************************************/
void main () {
 ANSELA=0;
 ANSELC=0;
 TRISA=0;
 LATA=0x00;

 INTCON.GIE = 1;      //enable global interrupt
 INTCON.PEIE = 1;
 PIE1.RCIE = 1; //enable receive interrupt.
 UART1_Init(19200);
    rc_ptr=buf;
    tx_ptr=buf;
 while(1) {   // Begin endless loop
  // This section is where you tell the program what to do with the data once it
  // has all arrived
     while(msgs!=0){         //read all the messages
     
   strncpy(output,tx_ptr,8);   //copy 8 bytes from the buffer
   Uart1_Write_Text("DATA:");
   Uart1_Write_Text(output);
   Uart1_Write(13);              //new line char
   tx_ptr=tx_ptr+8;               // increment the tr_ptr to the next 8 bytes
   if( tx_ptr - buf ==1024){      //if tx_ptr reaches the end of buffer loop back to beginning
   tx_ptr = buf;
   }
   msgs=msgs-1;
      }
 } // end while
} // end main